Index: /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 127)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 127)
@@ -0,0 +1,674 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjsip/sip_ua_layer.h>
+#include <pjsip/sip_module.h>
+#include <pjsip/sip_dialog.h>
+#include <pjsip/sip_endpoint.h>
+#include <pjsip/sip_errno.h>
+#include <pjsip/sip_transaction.h>
+#include <pj/os.h>
+#include <pj/hash.h>
+#include <pj/assert.h>
+#include <pj/string.h>
+#include <pj/pool.h>
+#include <pj/log.h>
+
+
+#define THIS_FILE    "sip_ua_layer.c"
+
+/*
+ * Static prototypes.
+ */
+static pj_status_t mod_ua_load(pjsip_endpoint *endpt);
+static pj_status_t mod_ua_unload(void);
+static pj_bool_t   mod_ua_on_rx_request(pjsip_rx_data *rdata);
+static pj_bool_t   mod_ua_on_rx_response(pjsip_rx_data *rdata);
+static void	   mod_ua_on_tsx_state(pjsip_transaction*, pjsip_event*);
+
+
+extern long pjsip_dlg_lock_tls_id;	/* defined in sip_dialog.c */
+
+/* This struct is used to represent list of dialog inside a dialog set.
+ * We don't want to use pjsip_dialog for this purpose, to save some
+ * memory (about 100 bytes per dialog set).
+ */
+struct dlg_set_head
+{
+    PJ_DECL_LIST_MEMBER(pjsip_dialog);
+};
+
+/* This struct represents a dialog set.
+ * This is the value that will be put in the UA's hash table.
+ */
+struct dlg_set
+{
+    /* To put this node in free dlg_set nodes in UA. */
+    PJ_DECL_LIST_MEMBER(struct dlg_set);
+
+    /* This is the buffer to store this entry in the hash table. */
+    char ht_entry[PJ_HASH_ENTRY_SIZE];
+
+    /* List of dialog in this dialog set. */
+    struct dlg_set_head  dlg_list;
+};
+
+
+/*
+ * Module interface.
+ */
+static struct user_agent
+{
+    pjsip_module	 mod;
+    pj_pool_t		*pool;
+    pjsip_endpoint	*endpt;
+    pj_mutex_t		*mutex;
+    pj_hash_table_t	*dlg_table;
+    pjsip_ua_init_param  param;
+    struct dlg_set	 free_dlgset_nodes;
+
+} mod_ua = 
+{
+  {
+    NULL, NULL,		    /* prev, next.			*/
+    { "mod-ua", 6 },	    /* Name.				*/
+    -1,			    /* Id				*/
+    PJSIP_MOD_PRIORITY_UA_PROXY_LAYER,	/* Priority		*/
+    NULL,		    /* User data.			*/
+    &mod_ua_load,	    /* load()				*/
+    NULL,		    /* start()				*/
+    NULL,		    /* stop()				*/
+    &mod_ua_unload,	    /* unload()				*/
+    &mod_ua_on_rx_request,  /* on_rx_request()			*/
+    &mod_ua_on_rx_response, /* on_rx_response()			*/
+    NULL,		    /* on_tx_request.			*/
+    NULL,		    /* on_tx_response()			*/
+    &mod_ua_on_tsx_state,   /* on_tsx_state()			*/
+  }
+};
+
+/* 
+ * mod_ua_load()
+ *
+ * Called when module is being loaded by endpoint.
+ */
+static pj_status_t mod_ua_load(pjsip_endpoint *endpt)
+{
+    pj_status_t status;
+
+    /* Initialize the user agent. */
+    mod_ua.endpt = endpt;
+    mod_ua.pool = pjsip_endpt_create_pool( endpt, "ua%p", PJSIP_POOL_LEN_UA,
+					   PJSIP_POOL_INC_UA);
+    if (mod_ua.pool == NULL)
+	return PJ_ENOMEM;
+
+    status = pj_mutex_create_recursive(mod_ua.pool, " ua%p", &mod_ua.mutex);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    mod_ua.dlg_table = pj_hash_create(mod_ua.pool, PJSIP_MAX_DIALOG_COUNT);
+    if (mod_ua.dlg_table == NULL)
+	return PJ_ENOMEM;
+
+    pj_list_init(&mod_ua.free_dlgset_nodes);
+
+    /* Initialize dialog lock. */
+    status = pj_thread_local_alloc(&pjsip_dlg_lock_tls_id);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    pj_thread_local_set(pjsip_dlg_lock_tls_id, NULL);
+
+    return PJ_SUCCESS;
+
+}
+
+/*
+ * mod_ua_unload()
+ *
+ * Called when module is being unloaded.
+ */
+static pj_status_t mod_ua_unload(void)
+{
+    pj_thread_local_free(pjsip_dlg_lock_tls_id);
+    pj_mutex_destroy(mod_ua.mutex);
+
+    /* Release pool */
+    if (mod_ua.pool) {
+	pjsip_endpt_release_pool( mod_ua.endpt, mod_ua.pool );
+    }
+    return PJ_SUCCESS;
+}
+
+/*
+ * mod_ua_on_tsx_stats()
+ *
+ * Called on changed on transaction state.
+ */
+static void mod_ua_on_tsx_state( pjsip_transaction *tsx, pjsip_event *e)
+{
+    pjsip_dialog *dlg;
+
+    /* Get the dialog where this transaction belongs. */
+    dlg = tsx->mod_data[mod_ua.mod.id];
+    
+    /* Must have the dialog instance! */
+    PJ_ASSERT_ON_FAIL(dlg != NULL, return);
+
+    /* Hand over the event to the dialog. */
+    pjsip_dlg_on_tsx_state(dlg, tsx, e);
+}
+
+
+/*
+ * Init user agent module and register it to the endpoint.
+ */
+PJ_DEF(pj_status_t) pjsip_ua_init( pjsip_endpoint *endpt,
+				   const pjsip_ua_init_param *prm)
+{
+    pj_status_t status;
+
+    /* Check if module already registered. */
+    PJ_ASSERT_RETURN(mod_ua.mod.id == -1, PJ_EINVALIDOP);
+
+    /* Copy param, if exists. */
+    if (prm)
+	pj_memcpy(&mod_ua.param, prm, sizeof(pjsip_ua_init_param));
+
+    /* Register the module. */
+    status = pjsip_endpt_register_module(endpt, &mod_ua.mod);
+
+    return status;
+}
+
+/*
+ * Get the instance of the user agent.
+ *
+ */
+PJ_DEF(pjsip_user_agent*) pjsip_ua_instance(void)
+{
+    return &mod_ua.mod;
+}
+
+
+/*
+ * Destroy the user agent layer.
+ */
+PJ_DEF(pj_status_t) pjsip_ua_destroy(void)
+{
+    /* Check if module already destroyed. */
+    PJ_ASSERT_RETURN(mod_ua.mod.id != -1, PJ_EINVALIDOP);
+
+    return pjsip_endpt_unregister_module(mod_ua.endpt, &mod_ua.mod);
+}
+
+
+
+/*
+ * Create key to identify dialog set.
+ */
+PJ_DEF(void) pjsip_ua_create_dlg_set_key( pj_pool_t *pool,
+					  pj_str_t *set_key,
+					  const pj_str_t *call_id,
+					  const pj_str_t *local_tag)
+{
+    PJ_ASSERT_ON_FAIL(pool && set_key && call_id && local_tag, return;);
+
+    set_key->slen = call_id->slen + local_tag->slen + 1;
+    set_key->ptr = pj_pool_alloc(pool, set_key->slen);
+    pj_assert(set_key->ptr != NULL);
+
+    pj_memcpy(set_key->ptr, call_id->ptr, call_id->slen);
+    set_key->ptr[call_id->slen] = '$';
+    pj_memcpy(set_key->ptr + call_id->slen + 1, 
+	      local_tag->ptr, local_tag->slen);
+}
+
+/*
+ * Acquire one dlg_set node to be put in the hash table.
+ * This will first look in the free nodes list, then allocate
+ * a new one from UA's pool when one is not available.
+ */
+static struct dlg_set *alloc_dlgset_node(void)
+{
+    struct dlg_set *set;
+
+    if (!pj_list_empty(&mod_ua.free_dlgset_nodes)) {
+	set = mod_ua.free_dlgset_nodes.next;
+	pj_list_erase(set);
+	return set;
+    } else {
+	set = pj_pool_alloc(mod_ua.pool, sizeof(struct dlg_set));
+	return set;
+    }
+}
+
+/*
+ * Register new dialog. Called by pjsip_dlg_create_uac() and
+ * pjsip_dlg_create_uas();
+ */
+PJ_DEF(pj_status_t) pjsip_ua_register_dlg( pjsip_user_agent *ua,
+					   pjsip_dialog *dlg )
+{
+    /* Sanity check. */
+    PJ_ASSERT_RETURN(ua && dlg, PJ_EINVAL);
+
+    /* For all dialogs, local tag (inc hash) must has been initialized. */
+    PJ_ASSERT_RETURN(dlg->local.info && dlg->local.info->tag.slen &&
+		     dlg->local.tag_hval != 0, PJ_EBUG);
+
+    /* For UAS dialog, remote tag (inc hash) must have been initialized. */
+    PJ_ASSERT_RETURN(dlg->role==PJSIP_ROLE_UAC ||
+		     (dlg->role==PJSIP_ROLE_UAS && dlg->remote.info->tag.slen
+		      && dlg->remote.tag_hval != 0), PJ_EBUG);
+
+    /* Lock the user agent. */
+    pj_mutex_lock(mod_ua.mutex);
+
+    /* For UAC, check if there is existing dialog in the same set. */
+    if (dlg->role == PJSIP_ROLE_UAC) {
+	struct dlg_set *dlg_set;
+
+	dlg_set = pj_hash_get( mod_ua.dlg_table, dlg->local.info->tag.ptr, 
+			       dlg->local.info->tag.slen,
+			       &dlg->local.tag_hval);
+
+	if (dlg_set) {
+	    /* This is NOT the first dialog in the dialog set. 
+	     * Just add this dialog in the list.
+	     */
+	    pj_assert(dlg_set->dlg_list.next != (void*)&dlg_set->dlg_list);
+	    pj_list_push_back(&dlg_set->dlg_list, dlg);
+
+	    dlg->dlg_set = dlg_set;
+
+	} else {
+	    /* This is the first dialog in the dialog set. 
+	     * Create the dialog set and add this dialog to it.
+	     */
+	    dlg_set = alloc_dlgset_node();
+	    pj_list_init(&dlg_set->dlg_list);
+	    pj_list_push_back(&dlg_set->dlg_list, dlg);
+
+	    dlg->dlg_set = dlg_set;
+
+	    /* Register the dialog set in the hash table. */
+	    pj_hash_set_np(mod_ua.dlg_table, 
+			   dlg->local.info->tag.ptr, dlg->local.info->tag.slen,
+			   dlg->local.tag_hval, dlg_set->ht_entry, dlg_set);
+	}
+
+    } else {
+	/* For UAS, create the dialog set with a single dialog as member. */
+	struct dlg_set *dlg_set;
+
+	dlg_set = alloc_dlgset_node();
+	pj_list_init(&dlg_set->dlg_list);
+	pj_list_push_back(&dlg_set->dlg_list, dlg);
+
+	dlg->dlg_set = dlg_set;
+
+	pj_hash_set_np(mod_ua.dlg_table, 
+		       dlg->local.info->tag.ptr, dlg->local.info->tag.slen,
+		       dlg->local.tag_hval, dlg_set->ht_entry, dlg_set);
+    }
+
+    /* Unlock user agent. */
+    pj_mutex_unlock(mod_ua.mutex);
+
+    /* Done. */
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_ua_unregister_dlg( pjsip_user_agent *ua,
+					     pjsip_dialog *dlg )
+{
+    struct dlg_set *dlg_set;
+    pjsip_dialog *d;
+
+    /* Sanity-check arguments. */
+    PJ_ASSERT_RETURN(ua && dlg, PJ_EINVAL);
+
+    /* Check that dialog has been registered. */
+    PJ_ASSERT_RETURN(dlg->dlg_set, PJ_EINVALIDOP);
+
+    /* Lock user agent. */
+    pj_mutex_lock(mod_ua.mutex);
+
+    /* Find this dialog from the dialog set. */
+    dlg_set = dlg->dlg_set;
+    d = dlg_set->dlg_list.next;
+    while (d != (pjsip_dialog*)&dlg_set->dlg_list && d != dlg) {
+	d = d->next;
+    }
+
+    if (d != dlg) {
+	pj_assert(!"Dialog is not registered!");
+	pj_mutex_unlock(mod_ua.mutex);
+	return PJ_EINVALIDOP;
+    }
+
+    /* Remove this dialog from the list. */
+    pj_list_erase(dlg);
+
+    /* If dialog list is empty, remove the dialog set from the hash table. */
+    if (pj_list_empty(&dlg_set->dlg_list)) {
+	pj_hash_set(NULL, mod_ua.dlg_table, dlg->local.info->tag.ptr,
+		    dlg->local.info->tag.slen, dlg->local.tag_hval, NULL);
+
+	/* Return dlg_set to free nodes. */
+	pj_list_push_back(&mod_ua.free_dlgset_nodes, dlg_set);
+    }
+
+    /* Unlock user agent. */
+    pj_mutex_unlock(mod_ua.mutex);
+
+    /* Done. */
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pjsip_dialog*) pjsip_rdata_get_dlg( pjsip_rx_data *rdata )
+{
+    return rdata->endpt_info.mod_data[mod_ua.mod.id];
+}
+
+PJ_DEF(pjsip_dialog*) pjsip_tsx_get_dlg( pjsip_transaction *tsx )
+{
+    return tsx->mod_data[mod_ua.mod.id];
+}
+
+
+/*
+ * Find the first dialog in dialog set in hash table for an incoming message.
+ */
+static struct dlg_set *find_dlg_set_for_msg( pjsip_rx_data *rdata )
+{
+    /* CANCEL message doesn't have To tag, so we must lookup the dialog
+     * by finding the INVITE UAS transaction being cancelled.
+     */
+    if (rdata->msg_info.cseq->method.id == PJSIP_CANCEL_METHOD) {
+
+	pjsip_dialog *dlg;
+
+	/* Create key for the rdata, but this time, use INVITE as the
+	 * method.
+	 */
+	pj_str_t key;
+	pjsip_role_e role;
+	pjsip_transaction *tsx;
+
+	if (rdata->msg_info.msg->type == PJSIP_REQUEST_MSG)
+	    role = PJSIP_ROLE_UAS;
+	else
+	    role = PJSIP_ROLE_UAC;
+
+	pjsip_tsx_create_key(rdata->tp_info.pool, &key, role, 
+			     &pjsip_invite_method, rdata);
+
+	/* Lookup the INVITE transaction */
+	tsx = pjsip_tsx_layer_find_tsx(&key, PJ_TRUE);
+
+	/* We should find the dialog attached to the INVITE transaction */
+	if (tsx) {
+	    dlg = tsx->mod_data[mod_ua.mod.id];
+	    pj_mutex_unlock(tsx->mutex);
+
+	    return dlg->dlg_set;
+
+	} else {
+	    return NULL;
+	}
+
+
+    } else {
+	pj_str_t *tag;
+	struct dlg_set *dlg_set;
+
+	if (rdata->msg_info.msg->type == PJSIP_REQUEST_MSG)
+	    tag = &rdata->msg_info.to->tag;
+	else
+	    tag = &rdata->msg_info.from->tag;
+
+	/* Lookup the dialog set. */
+	dlg_set = pj_hash_get(mod_ua.dlg_table, tag->ptr, tag->slen, NULL);
+	return dlg_set;
+    }
+}
+
+/* On received requests. */
+static pj_bool_t mod_ua_on_rx_request(pjsip_rx_data *rdata)
+{
+    struct dlg_set *dlg_set;
+    pj_str_t *from_tag;
+    pjsip_dialog *dlg;
+
+    /* Lock user agent before looking up the dialog hash table. */
+    pj_mutex_lock(mod_ua.mutex);
+
+    /* Lookup the dialog set, based on the To tag header. */
+    dlg_set = find_dlg_set_for_msg(rdata);
+
+    /* Bail out if dialog is not found. */
+    if (dlg_set == NULL) {
+	/* Not ours. */
+	pj_mutex_unlock(mod_ua.mutex);
+	return PJ_FALSE;
+    }
+
+    /* Dialog set has been found.
+     * Find the dialog in the dialog set based on the content of the From tag.
+     */
+    from_tag = &rdata->msg_info.from->tag;
+    dlg = dlg_set->dlg_list.next;
+    while (dlg != (pjsip_dialog*)&dlg_set->dlg_list) {
+	
+	if (pj_strcmp(&dlg->remote.info->tag, from_tag) == 0)
+	    break;
+
+	dlg = dlg->next;
+    }
+
+    /* Dialog MUST be found! */
+    if (dlg == (pjsip_dialog*)&dlg_set->dlg_list) {
+	/* Not found. Mulfunction UAC? */
+	pj_mutex_unlock(mod_ua.mutex);
+	pjsip_endpt_respond_stateless(mod_ua.endpt, rdata,
+				      PJSIP_SC_CALL_TSX_DOES_NOT_EXIST, 
+				      NULL, NULL, NULL);
+	return PJ_TRUE;
+    }
+
+    /* Mark the dialog id of the request. */
+    rdata->endpt_info.mod_data[mod_ua.mod.id] = dlg;
+
+    /* Done processing in the UA */
+    pj_mutex_unlock(mod_ua.mutex);
+
+    /* Pass to dialog. */
+    pjsip_dlg_on_rx_request(dlg, rdata);
+
+    /* Report as handled. */
+    return PJ_TRUE;
+}
+
+
+/* On rx response notification.
+ */
+static pj_bool_t mod_ua_on_rx_response(pjsip_rx_data *rdata)
+{
+    pjsip_transaction *tsx;
+    struct dlg_set *dlg_set;
+    pjsip_dialog *dlg = NULL;
+
+    /*
+     * Find the dialog instance for the response.
+     * All outgoing dialog requests are sent statefully, which means
+     * there will be an UAC transaction associated with this response,
+     * and the dialog instance will be recorded in that transaction.
+     *
+     * But even when transaction is found, there is possibility that
+     * the response is a forked response.
+     */
+
+    /* Check if transaction is present. */
+    tsx = pjsip_rdata_get_tsx(rdata);
+    if (!tsx) {
+	/* Check if dialog is present in the transaction. */
+	dlg = pjsip_tsx_get_dlg(tsx);
+	if (!dlg)
+	    return PJ_FALSE;
+
+	/* Get the dialog set. */
+	dlg_set = dlg->dlg_set;
+
+	/* Even if transaction is found and (candidate) dialog has been 
+	 * identified, it's possible that the request has forked.
+	 */
+
+    } else {
+	/* Transaction is not present.
+	 * Check if this is a 2xx/OK response to INVITE, which in this
+	 * case the response will be handled directly by the
+	 * dialog.
+	 */
+	pjsip_cseq_hdr *cseq_hdr = rdata->msg_info.cseq;
+
+	if (cseq_hdr->method.id != PJSIP_INVITE_METHOD ||
+	    rdata->msg_info.msg->line.status.code / 100 != 2)
+	{
+	    /* Not a 2xx response to INVITE.
+	     * This must be some stateless response sent by other modules,
+	     * or a very late response.
+	     */
+	    return PJ_FALSE;
+	}
+
+	/* Lock user agent before accessing the hash table. */
+	pj_mutex_lock(mod_ua.mutex);
+
+	/* Get the dialog set. */
+	dlg_set = pj_hash_get(mod_ua.dlg_table, 
+			      rdata->msg_info.from->tag.ptr,
+			      rdata->msg_info.from->tag.slen,
+			      NULL);
+
+	/* Done with accessing the hash table. */
+	pj_mutex_unlock(mod_ua.mutex);
+
+	if (!dlg_set) {
+	    /* Strayed 2xx response!! */
+	    PJ_LOG(4,(THIS_FILE, 
+		      "Received strayed 2xx response (no dialog is found)"
+		      " from %s:%d: %s",
+		      rdata->pkt_info.src_name, rdata->pkt_info.src_port,
+		      pjsip_rx_data_get_info(rdata)));
+
+	    return PJ_TRUE;
+	}
+    }
+
+    /* At this point, we must have the dialog set, and the dialog set
+     * must have a dialog in the list.
+     */
+    pj_assert(dlg_set && !pj_list_empty(&dlg_set->dlg_list));
+
+    /* Check for forked response. 
+     * Request will fork only for the initial INVITE request.
+     */
+    if (rdata->msg_info.cseq->method.id == PJSIP_INVITE_METHOD &&
+	rdata->msg_info.cseq->cseq == dlg_set->dlg_list.next->local.first_cseq)
+    {
+	pj_str_t *to_tag = &rdata->msg_info.to->tag;
+
+	/* Must hold UA mutex before accessing dialog set. */
+	pj_mutex_lock(mod_ua.mutex);
+
+	dlg = dlg_set->dlg_list.next;
+	while (dlg != (pjsip_dialog*)&dlg_set->dlg_list) {
+
+	    /* If there is dialog with no remote tag (i.e. dialog has not
+	     * been established yet), then send this response to that
+	     * dialog.
+	     */
+	    if (dlg->remote.info->tag.slen == 0)
+		break;
+
+	    /* Otherwise find the one with matching To tag. */
+	    if (pj_strcmp(to_tag, &dlg->remote.info->tag) == 0)
+		break;
+
+	    dlg = dlg->next;
+	}
+
+	/* If no dialog with matching remote tag is found, this must be
+	 * a forked response.
+	 */
+	if (dlg == (pjsip_dialog*)&dlg_set->dlg_list) {
+	    /* Report to application about forked condition.
+	     * Application can either create a dialog or ignore the response.
+	     */
+	    if (mod_ua.param.on_dlg_forked)
+		dlg = (*mod_ua.param.on_dlg_forked)(dlg_set->dlg_list.next, 
+						    rdata);
+	    else
+		dlg = NULL;
+
+	    /* Ignore this response if application doesn't want to
+	     * create a dialog.
+	     */
+	    if (dlg == NULL) {
+		pj_mutex_unlock(mod_ua.mutex);
+
+		PJ_LOG(4,(THIS_FILE, 
+			  "Unhandled forked %s from %s:%d",
+			  pjsip_rx_data_get_info(rdata),
+			  rdata->pkt_info.src_name, rdata->pkt_info.src_port));
+
+		return PJ_TRUE;
+	    }
+	}
+
+	/* Done with the dialog set. */
+	pj_mutex_unlock(mod_ua.mutex);
+
+    } else {
+	/* Either this is a non-INVITE response, or subsequent INVITE
+	 * within dialog. The dialog should have been identified when
+	 * the transaction was found.
+	 */
+	pj_assert(tsx != NULL);
+	pj_assert(dlg != NULL);
+    }
+
+    /* The dialog must have been found. */
+    pj_assert(dlg != NULL);
+
+    /* Put the dialog instance in the rdata. */
+    rdata->endpt_info.mod_data[mod_ua.mod.id] = dlg;
+
+    /* Pass the response to the dialog. */
+    pjsip_dlg_on_rx_response(dlg, rdata);
+
+    /* Done. */
+    return PJ_TRUE;
+}
+
+
Index: /pjproject/trunk/pjsip/src/pjsip/sip_uri.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 127)
@@ -141,13 +141,13 @@
 static pjsip_name_addr* pjsip_name_addr_clone( pj_pool_t *pool, 
 					       const pjsip_name_addr *rhs);
-static int pjsip_name_addr_print( pjsip_uri_context_e context,
-				  const pjsip_name_addr *name, 
-				  char *buf, pj_size_t size);
+static pj_ssize_t pjsip_name_addr_print(pjsip_uri_context_e context,
+					const pjsip_name_addr *name, 
+					char *buf, pj_size_t size);
 static int pjsip_name_addr_compare(  pjsip_uri_context_e context,
 				     const pjsip_name_addr *naddr1,
 				     const pjsip_name_addr *naddr2);
-static int pjsip_url_print(  pjsip_uri_context_e context,
-			     const pjsip_sip_uri *url, 
-			     char *buf, pj_size_t size);
+static pj_ssize_t pjsip_url_print(  pjsip_uri_context_e context,
+				    const pjsip_sip_uri *url, 
+				    char *buf, pj_size_t size);
 static int pjsip_url_compare( pjsip_uri_context_e context,
 			      const pjsip_sip_uri *url1, 
@@ -205,5 +205,5 @@
 }
 
-PJ_DEF(void) pjsip_url_init(pjsip_sip_uri *url, int secure)
+PJ_DEF(void) pjsip_sip_uri_init(pjsip_sip_uri *url, int secure)
 {
     pj_memset(url, 0, sizeof(*url));
@@ -214,14 +214,14 @@
 }
 
-PJ_DEF(pjsip_sip_uri*) pjsip_url_create( pj_pool_t *pool, int secure )
+PJ_DEF(pjsip_sip_uri*) pjsip_sip_uri_create( pj_pool_t *pool, int secure )
 {
     pjsip_sip_uri *url = pj_pool_alloc(pool, sizeof(pjsip_sip_uri));
-    pjsip_url_init(url, secure);
+    pjsip_sip_uri_init(url, secure);
     return url;
 }
 
-static int pjsip_url_print(  pjsip_uri_context_e context,
-			     const pjsip_sip_uri *url, 
-			     char *buf, pj_size_t size)
+static pj_ssize_t pjsip_url_print(  pjsip_uri_context_e context,
+				    const pjsip_sip_uri *url, 
+				    char *buf, pj_size_t size)
 {
     int printed;
@@ -466,6 +466,6 @@
 
 
-PJ_DEF(void) pjsip_url_assign(pj_pool_t *pool, pjsip_sip_uri *url, 
-			      const pjsip_sip_uri *rhs)
+PJ_DEF(void) pjsip_sip_uri_assign(pj_pool_t *pool, pjsip_sip_uri *url, 
+				  const pjsip_sip_uri *rhs)
 {
     pj_strdup( pool, &url->user, &rhs->user);
@@ -489,6 +489,6 @@
 	return NULL;
 
-    pjsip_url_init(url, IS_SIPS(rhs));
-    pjsip_url_assign(pool, url, rhs);
+    pjsip_sip_uri_init(url, IS_SIPS(rhs));
+    pjsip_sip_uri_assign(pool, url, rhs);
     return url;
 }
@@ -514,7 +514,7 @@
 }
 
-static int pjsip_name_addr_print( pjsip_uri_context_e context,
-				  const pjsip_name_addr *name, 
-				  char *buf, pj_size_t size)
+static pj_ssize_t pjsip_name_addr_print(pjsip_uri_context_e context,
+					const pjsip_name_addr *name, 
+					char *buf, pj_size_t size)
 {
     int printed;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_util.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 127)
@@ -129,7 +129,7 @@
 	    pjsip_generic_string_hdr *hdr;
 
-	    hdr = pjsip_generic_string_hdr_create_with_text(tdata->pool, 
-							    &hparam->name,
-							    &hparam->value);
+	    hdr = pjsip_generic_string_hdr_create(tdata->pool, 
+						  &hparam->name,
+						  &hparam->value);
 	    pjsip_msg_add_hdr(msg, (pjsip_hdr*)hdr);
 	    hparam = hparam->next;
@@ -303,7 +303,7 @@
 	target = pjsip_uri_clone(tdata->pool, param_target);
 	from = pjsip_hdr_clone(tdata->pool, param_from);
-	pjsip_fromto_set_from(from);
+	pjsip_fromto_hdr_set_from(from);
 	to = pjsip_hdr_clone(tdata->pool, param_to);
-	pjsip_fromto_set_to(to);
+	pjsip_fromto_hdr_set_to(to);
 	if (param_contact)
 	    contact = pjsip_hdr_clone(tdata->pool, param_contact);
Index: /pjproject/trunk/pjsip/src/test-pjsip/dlg_core_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/dlg_core_test.c	(revision 127)
+++ /pjproject/trunk/pjsip/src/test-pjsip/dlg_core_test.c	(revision 127)
@@ -0,0 +1,22 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+#include "test.h"
+#include <pjsip.h>
+
Index: /pjproject/trunk/pjsip/src/test-pjsip/msg_logger.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/msg_logger.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/test-pjsip/msg_logger.c	(revision 127)
@@ -18,5 +18,5 @@
  */
 #include "test.h"
-#include <pjsip_core.h>
+#include <pjsip.h>
 #include <pjlib.h>
 
@@ -65,6 +65,4 @@
     PJSIP_MOD_PRIORITY_TRANSPORT_LAYER-1,/* Priority		*/
     NULL,				/* User data.		*/
-    0,					/* Number of methods supported (=0). */
-    { 0 },				/* Array of methods (none) */
     NULL,				/* load()		*/
     NULL,				/* start()		*/
Index: /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 127)
@@ -18,5 +18,5 @@
  */
 #include "test.h"
-#include <pjsip_core.h>
+#include <pjsip.h>
 #include <pjlib.h>
 
@@ -349,5 +349,5 @@
     /* "INVITE sip:user@foo SIP/2.0\n" */
     pjsip_method_set(&msg->line.req.method, PJSIP_INVITE_METHOD);
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     msg->line.req.uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "user");
@@ -361,5 +361,5 @@
     fromto->uri = (pjsip_uri*)name_addr;
     pj_strdup2(pool, &name_addr->display, "Hi I'm Joe");
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     name_addr->uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "joe.user");
@@ -372,5 +372,5 @@
     fromto->uri = (pjsip_uri*)name_addr;
     pj_strdup2(pool, &name_addr->display, "Fellow User");
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     name_addr->uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "user");
@@ -400,5 +400,5 @@
     name_addr = pjsip_name_addr_create(pool);
     contact->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     name_addr->uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "joe");
@@ -411,5 +411,5 @@
     name_addr = pjsip_name_addr_create(pool);
     contact->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     name_addr->uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "user");
@@ -421,5 +421,5 @@
     name_addr = pjsip_name_addr_create(pool);
     contact->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     name_addr->uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->user, "user2");
@@ -436,5 +436,5 @@
     routing = pjsip_route_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)routing);
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     routing->name_addr.uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->host, "bigbox3.site3.atlanta.com");
@@ -444,5 +444,5 @@
     routing = pjsip_route_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)routing);
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     routing->name_addr.uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->host, "server10.biloxi.com");
@@ -452,5 +452,5 @@
     routing = pjsip_rr_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)routing);
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     routing->name_addr.uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->host, "server10.biloxi.com");
@@ -460,5 +460,5 @@
     routing = pjsip_rr_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)routing);
-    url = pjsip_url_create(pool, 0);
+    url = pjsip_sip_uri_create(pool, 0);
     routing->name_addr.uri = (pjsip_uri*)url;
     pj_strdup2(pool, &url->host, "bigbox3.site3.atlanta.com");
@@ -498,5 +498,5 @@
     str.ptr = "Organization";
     str.slen = 12;
-    generic = pjsip_generic_string_hdr_create(pool, &str);
+    generic = pjsip_generic_string_hdr_create(pool, &str, NULL);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
     generic->hvalue.ptr = NULL;
@@ -506,5 +506,5 @@
     str.ptr = "Max-Forwards";
     str.slen = 12;
-    generic = pjsip_generic_string_hdr_create(pool, &str);
+    generic = pjsip_generic_string_hdr_create(pool, &str, NULL);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
     str.ptr = "70";
@@ -515,5 +515,5 @@
     str.ptr = "X-Header";
     str.slen = 8;
-    generic = pjsip_generic_string_hdr_create(pool, &str);
+    generic = pjsip_generic_string_hdr_create(pool, &str, NULL);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
     str.ptr = NULL;
@@ -524,5 +524,5 @@
     str.ptr = "P-Associated-URI";
     str.slen = 16;
-    generic = pjsip_generic_string_hdr_create(pool, &str);
+    generic = pjsip_generic_string_hdr_create(pool, &str, NULL);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
     str.ptr = NULL;
@@ -539,5 +539,5 @@
     pjsip_name_addr *name_addr;
     pjsip_sip_uri *url;
-    pjsip_max_forwards_hdr *max_fwd;
+    pjsip_max_fwd_hdr *max_fwd;
     pjsip_to_hdr *to;
     pjsip_from_hdr *from;
@@ -582,5 +582,5 @@
     route = pjsip_route_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)route);
-    url = pjsip_url_create(pool, PJ_FALSE);
+    url = pjsip_sip_uri_create(pool, PJ_FALSE);
     route->name_addr.uri = (pjsip_uri*)url;
     url->host = pj_str("proxy.sipprovider.com");
@@ -589,5 +589,5 @@
     route = pjsip_route_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)route);
-    url = pjsip_url_create(pool, PJ_FALSE);
+    url = pjsip_sip_uri_create(pool, PJ_FALSE);
     route->name_addr.uri = (pjsip_uri*)url;
     url->host = pj_str("proxy.supersip.com");
@@ -595,7 +595,6 @@
 
     //"Max-Forwards: 70\r\n"
-    max_fwd = pjsip_max_forwards_hdr_create(pool);
+    max_fwd = pjsip_max_fwd_hdr_create(pool, 70);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)max_fwd);
-    max_fwd->ivalue = 70;
 
     //"To: Bob <sip:bob@biloxi.com>;tag=a6c85cf\r\n"
@@ -605,5 +604,5 @@
     name_addr->display = pj_str("Bob");
     to->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, PJ_FALSE);
+    url = pjsip_sip_uri_create(pool, PJ_FALSE);
     name_addr->uri = (pjsip_uri*)url;
     url->user = pj_str("bob");
@@ -617,5 +616,5 @@
     name_addr->display = pj_str("Alice");
     from->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, PJ_FALSE);
+    url = pjsip_sip_uri_create(pool, PJ_FALSE);
     name_addr->uri = (pjsip_uri*)url;
     url->user = pj_str("alice");
@@ -639,5 +638,5 @@
     name_addr = pjsip_name_addr_create(pool);
     contact->uri = (pjsip_uri*)name_addr;
-    url = pjsip_url_create(pool, PJ_TRUE);
+    url = pjsip_sip_uri_create(pool, PJ_TRUE);
     name_addr->uri = (pjsip_uri*)url;
     url->user = pj_str("bob");
Index: /pjproject/trunk/pjsip/src/test-pjsip/test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/test.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/test-pjsip/test.c	(revision 127)
@@ -21,5 +21,5 @@
 #include "test.h"
 #include <pjlib.h>
-#include <pjsip_core.h>
+#include <pjsip.h>
 
 #define THIS_FILE   "test.c"
Index: /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c	(revision 127)
@@ -19,5 +19,5 @@
 
 #include "test.h"
-#include <pjsip_core.h>
+#include <pjsip.h>
 #include <pjlib.h>
 
